package io.dekorate.halkyon.adapter;

import java.nio.file.Path;
import java.util.stream.Collectors;
import java.lang.String;
import java.util.Comparator;
import io.dekorate.project.Project;
import io.dekorate.project.BuildInfo;
import io.dekorate.halkyon.annotation.HalkyonRequiredCapability;
import io.dekorate.halkyon.config.Parameter;
import io.dekorate.halkyon.config.RequiredCapabilityConfig;
import io.dekorate.project.ScmInfo;
import java.util.Arrays;
import io.dekorate.halkyon.config.RequiredCapabilityConfigBuilder;
import java.util.Map;

public class RequiredCapabilityConfigAdapter{



    public static RequiredCapabilityConfig adapt(HalkyonRequiredCapability instance){
            return newBuilder(instance).build();
    }

    public static RequiredCapabilityConfigBuilder newBuilder(HalkyonRequiredCapability instance){
            return new RequiredCapabilityConfigBuilder(new io.dekorate.halkyon.config.RequiredCapabilityConfig(null,
            null,
            instance.name(),
            instance.category(),
            instance.type(),
            instance.boundTo(),
            instance.autoBindable(),
            Arrays.asList(instance.parameters()).stream().map(i ->new io.dekorate.halkyon.config.Parameter(i.name(),
            i.value())).collect(Collectors.toList()).toArray(new io.dekorate.halkyon.config.Parameter[0])));
    }

    public static RequiredCapabilityConfig adapt(Map map){
            return new io.dekorate.halkyon.config.RequiredCapabilityConfig(
null,
null,
               (String)(map instanceof Map ? ((Map)map).getOrDefault("name", "") : ""),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("category", "") : ""),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("type", "") : ""),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("boundTo", "") : ""),
               Boolean.parseBoolean(String.valueOf(map instanceof Map ? ((Map)map).getOrDefault("autoBindable","false") : "false")),
               Arrays.stream((Map[])(map instanceof Map ? ((Map)map).getOrDefault("parameters" , new Map[0]) : new Map[0])).map(i ->new io.dekorate.halkyon.config.Parameter(
               (String)(i instanceof Map ? ((Map)i).getOrDefault("name", null) : null),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("value", null) : null))).toArray(size-> new io.dekorate.halkyon.config.Parameter[size]));
    }

    public static RequiredCapabilityConfigBuilder newBuilder(Map map){
            return new RequiredCapabilityConfigBuilder(new io.dekorate.halkyon.config.RequiredCapabilityConfig(
null,
null,
               (String)(map instanceof Map ? ((Map)map).getOrDefault("name", "") : ""),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("category", "") : ""),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("type", "") : ""),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("boundTo", "") : ""),
               Boolean.parseBoolean(String.valueOf(map instanceof Map ? ((Map)map).getOrDefault("autoBindable","false") : "false")),
               Arrays.stream((Map[])(map instanceof Map ? ((Map)map).getOrDefault("parameters" , new Map[0]) : new Map[0])).map(i ->new io.dekorate.halkyon.config.Parameter(
               (String)(i instanceof Map ? ((Map)i).getOrDefault("name", null) : null),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("value", null) : null))).toArray(size-> new io.dekorate.halkyon.config.Parameter[size])));
    }




}
