package io.dekorate.halkyon.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import io.dekorate.kubernetes.config.Label;
import java.util.ArrayList;
import io.dekorate.kubernetes.config.ConfigurationFluent;
import java.lang.String;
import io.dekorate.kubernetes.config.Env;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import java.lang.Deprecated;
import java.util.Iterator;
import io.dekorate.halkyon.model.DeploymentMode;
import io.dekorate.kubernetes.config.LabelBuilder;
import java.lang.Boolean;
import io.dekorate.kubernetes.config.ConfigKey;
import io.dekorate.kubernetes.config.EnvFluent;
import io.dekorate.kubernetes.config.LabelFluent;
import io.dekorate.project.Project;
import java.lang.StringBuffer;
import io.dekorate.kubernetes.config.EnvBuilder;
import java.util.Collection;
import java.lang.Object;
import java.util.Map;

public interface ComponentConfigFluent<A extends ComponentConfigFluent<A>> extends ConfigurationFluent<A>{


    public String getPartOf();
    public A withPartOf(String partOf);
    public Boolean hasPartOf();
    public A withNewPartOf(String arg1);
    public A withNewPartOf(StringBuilder arg1);
    public A withNewPartOf(StringBuffer arg1);
    public String getName();
    public A withName(String name);
    public Boolean hasName();
    public A withNewName(String arg1);
    public A withNewName(StringBuilder arg1);
    public A withNewName(StringBuffer arg1);
    public String getVersion();
    public A withVersion(String version);
    public Boolean hasVersion();
    public A withNewVersion(String arg1);
    public A withNewVersion(StringBuilder arg1);
    public A withNewVersion(StringBuffer arg1);
    public DeploymentMode getDeploymentMode();
    public A withDeploymentMode(DeploymentMode deploymentMode);
    public Boolean hasDeploymentMode();
    public boolean isExposeService();
    public A withExposeService(boolean exposeService);
    public Boolean hasExposeService();
    public A withEnvs(io.dekorate.kubernetes.config.Env... envs);
    
/**
 * This method has been deprecated, please use method buildEnvs instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Env[] getEnvs();
    public io.dekorate.kubernetes.config.Env[] buildEnvs();
    public io.dekorate.kubernetes.config.Env buildEnv(int index);
    public io.dekorate.kubernetes.config.Env buildFirstEnv();
    public io.dekorate.kubernetes.config.Env buildLastEnv();
    public io.dekorate.kubernetes.config.Env buildMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.kubernetes.config.EnvBuilder> predicate);
    public Boolean hasMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.kubernetes.config.EnvBuilder> predicate);
    public A addToEnvs(int index,io.dekorate.kubernetes.config.Env item);
    public A setToEnvs(int index,io.dekorate.kubernetes.config.Env item);
    public A addToEnvs(io.dekorate.kubernetes.config.Env... items);
    public A addAllToConfigEnvs(Collection<io.dekorate.kubernetes.config.Env> items);
    public A removeFromEnvs(io.dekorate.kubernetes.config.Env... items);
    public A removeAllFromConfigEnvs(Collection<io.dekorate.kubernetes.config.Env> items);
    public A removeMatchingFromConfigEnvs(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.kubernetes.config.EnvBuilder> predicate);
    public Boolean hasEnvs();
    public A addNewConfigEnv(String name,String value,String secret,String configmap,String field);
    public ComponentConfigFluent.ConfigEnvsNested<A> addNewConfigEnv();
    public ComponentConfigFluent.ConfigEnvsNested<A> addNewEnvLike(io.dekorate.kubernetes.config.Env item);
    public ComponentConfigFluent.ConfigEnvsNested<A> setNewEnvLike(int index,io.dekorate.kubernetes.config.Env item);
    public ComponentConfigFluent.ConfigEnvsNested<A> editEnv(int index);
    public ComponentConfigFluent.ConfigEnvsNested<A> editFirstEnv();
    public ComponentConfigFluent.ConfigEnvsNested<A> editLastEnv();
    public ComponentConfigFluent.ConfigEnvsNested<A> editMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.kubernetes.config.EnvBuilder> predicate);
    public A withLabels(io.dekorate.kubernetes.config.Label... labels);
    
/**
 * This method has been deprecated, please use method buildLabels instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Label[] getLabels();
    public io.dekorate.kubernetes.config.Label[] buildLabels();
    public io.dekorate.kubernetes.config.Label buildLabel(int index);
    public io.dekorate.kubernetes.config.Label buildFirstLabel();
    public io.dekorate.kubernetes.config.Label buildLastLabel();
    public io.dekorate.kubernetes.config.Label buildMatchingLabel(io.dekorate.deps.kubernetes.api.builder.Predicate<LabelBuilder> predicate);
    public Boolean hasMatchingLabel(io.dekorate.deps.kubernetes.api.builder.Predicate<LabelBuilder> predicate);
    public A addToLabels(int index,io.dekorate.kubernetes.config.Label item);
    public A setToLabels(int index,io.dekorate.kubernetes.config.Label item);
    public A addToLabels(io.dekorate.kubernetes.config.Label... items);
    public A addAllToConfigLabels(Collection<io.dekorate.kubernetes.config.Label> items);
    public A removeFromLabels(io.dekorate.kubernetes.config.Label... items);
    public A removeAllFromConfigLabels(Collection<io.dekorate.kubernetes.config.Label> items);
    public A removeMatchingFromConfigLabels(io.dekorate.deps.kubernetes.api.builder.Predicate<LabelBuilder> predicate);
    public Boolean hasLabels();
    public A addNewConfigLabel(String key,String value);
    public ComponentConfigFluent.ConfigLabelsNested<A> addNewConfigLabel();
    public ComponentConfigFluent.ConfigLabelsNested<A> addNewLabelLike(io.dekorate.kubernetes.config.Label item);
    public ComponentConfigFluent.ConfigLabelsNested<A> setNewLabelLike(int index,io.dekorate.kubernetes.config.Label item);
    public ComponentConfigFluent.ConfigLabelsNested<A> editLabel(int index);
    public ComponentConfigFluent.ConfigLabelsNested<A> editFirstLabel();
    public ComponentConfigFluent.ConfigLabelsNested<A> editLastLabel();
    public ComponentConfigFluent.ConfigLabelsNested<A> editMatchingLabel(io.dekorate.deps.kubernetes.api.builder.Predicate<LabelBuilder> predicate);
    public String getBuildType();
    public A withBuildType(String buildType);
    public Boolean hasBuildType();
    public A withNewBuildType(String arg1);
    public A withNewBuildType(StringBuilder arg1);
    public A withNewBuildType(StringBuffer arg1);
    public String getRemote();
    public A withRemote(String remote);
    public Boolean hasRemote();
    public A withNewRemote(String arg1);
    public A withNewRemote(StringBuilder arg1);
    public A withNewRemote(StringBuffer arg1);
    public A withProvides(CapabilityConfig... provides);
    
/**
 * This method has been deprecated, please use method buildProvides instead.
 */
@Deprecated public CapabilityConfig[] getProvides();
    public CapabilityConfig[] buildProvides();
    public CapabilityConfig buildProvide(int index);
    public CapabilityConfig buildFirstProvide();
    public CapabilityConfig buildLastProvide();
    public CapabilityConfig buildMatchingProvide(io.dekorate.deps.kubernetes.api.builder.Predicate<CapabilityConfigBuilder> predicate);
    public Boolean hasMatchingProvide(io.dekorate.deps.kubernetes.api.builder.Predicate<CapabilityConfigBuilder> predicate);
    public A addToProvides(int index,CapabilityConfig item);
    public A setToProvides(int index,CapabilityConfig item);
    public A addToProvides(CapabilityConfig... items);
    public A addAllToProvides(Collection<CapabilityConfig> items);
    public A removeFromProvides(CapabilityConfig... items);
    public A removeAllFromProvides(Collection<CapabilityConfig> items);
    public A removeMatchingFromProvides(io.dekorate.deps.kubernetes.api.builder.Predicate<CapabilityConfigBuilder> predicate);
    public Boolean hasProvides();
    public ComponentConfigFluent.ProvidesNested<A> addNewProvide();
    public ComponentConfigFluent.ProvidesNested<A> addNewProvideLike(CapabilityConfig item);
    public ComponentConfigFluent.ProvidesNested<A> setNewProvideLike(int index,CapabilityConfig item);
    public ComponentConfigFluent.ProvidesNested<A> editProvide(int index);
    public ComponentConfigFluent.ProvidesNested<A> editFirstProvide();
    public ComponentConfigFluent.ProvidesNested<A> editLastProvide();
    public ComponentConfigFluent.ProvidesNested<A> editMatchingProvide(io.dekorate.deps.kubernetes.api.builder.Predicate<CapabilityConfigBuilder> predicate);
    public A withRequires(RequiredCapabilityConfig... requires);
    
/**
 * This method has been deprecated, please use method buildRequires instead.
 */
@Deprecated public RequiredCapabilityConfig[] getRequires();
    public RequiredCapabilityConfig[] buildRequires();
    public RequiredCapabilityConfig buildRequire(int index);
    public RequiredCapabilityConfig buildFirstRequire();
    public RequiredCapabilityConfig buildLastRequire();
    public RequiredCapabilityConfig buildMatchingRequire(io.dekorate.deps.kubernetes.api.builder.Predicate<RequiredCapabilityConfigBuilder> predicate);
    public Boolean hasMatchingRequire(io.dekorate.deps.kubernetes.api.builder.Predicate<RequiredCapabilityConfigBuilder> predicate);
    public A addToRequires(int index,RequiredCapabilityConfig item);
    public A setToRequires(int index,RequiredCapabilityConfig item);
    public A addToRequires(RequiredCapabilityConfig... items);
    public A addAllToRequires(Collection<RequiredCapabilityConfig> items);
    public A removeFromRequires(RequiredCapabilityConfig... items);
    public A removeAllFromRequires(Collection<RequiredCapabilityConfig> items);
    public A removeMatchingFromRequires(io.dekorate.deps.kubernetes.api.builder.Predicate<RequiredCapabilityConfigBuilder> predicate);
    public Boolean hasRequires();
    public ComponentConfigFluent.RequiresNested<A> addNewRequire();
    public ComponentConfigFluent.RequiresNested<A> addNewRequireLike(RequiredCapabilityConfig item);
    public ComponentConfigFluent.RequiresNested<A> setNewRequireLike(int index,RequiredCapabilityConfig item);
    public ComponentConfigFluent.RequiresNested<A> editRequire(int index);
    public ComponentConfigFluent.RequiresNested<A> editFirstRequire();
    public ComponentConfigFluent.RequiresNested<A> editLastRequire();
    public ComponentConfigFluent.RequiresNested<A> editMatchingRequire(io.dekorate.deps.kubernetes.api.builder.Predicate<RequiredCapabilityConfigBuilder> predicate);

    public interface ConfigEnvsNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,io.dekorate.kubernetes.config.EnvFluent<ComponentConfigFluent.ConfigEnvsNested<N>>{

        
    public N and();    public N endConfigEnv();
}
    public interface ConfigLabelsNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,LabelFluent<ComponentConfigFluent.ConfigLabelsNested<N>>{

        
    public N and();    public N endConfigLabel();
}
    public interface ProvidesNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,CapabilityConfigFluent<ComponentConfigFluent.ProvidesNested<N>>{

        
    public N and();    public N endProvide();
}
    public interface RequiresNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,RequiredCapabilityConfigFluent<ComponentConfigFluent.RequiresNested<N>>{

        
    public N and();    public N endRequire();
}


}
