package io.dekorate.halkyon.config;

import io.dekorate.project.Project;
import io.dekorate.kubernetes.config.ConfigKey;
import io.dekorate.kubernetes.config.Configuration;
import java.lang.Object;
import java.lang.String;
import java.util.Map;
import io.sundr.builder.annotations.Buildable;

@io.sundr.builder.annotations.Buildable(builderPackage = "io.dekorate.deps.kubernetes.api.builder") public class RequiredCapabilityConfig extends Configuration{

    private String name = "";
    private String category = "";
    private String type = "";
    private String boundTo = "";
    private boolean autoBindable = false;
    private io.dekorate.halkyon.config.Parameter[] parameters = new io.dekorate.halkyon.config.Parameter[0];

    public RequiredCapabilityConfig(){
    }
    public RequiredCapabilityConfig(Project project,Map<ConfigKey,Object> attributes,String name,String category,String type,String boundTo,boolean autoBindable,io.dekorate.halkyon.config.Parameter[] parameters){
            super(project, attributes);
            this.name = name != null ? name : "";
            this.category = category != null ? category : "";
            this.type = type != null ? type : "";
            this.boundTo = boundTo != null ? boundTo : "";
            this.autoBindable = autoBindable;
            this.parameters = parameters != null ? parameters : new io.dekorate.halkyon.config.Parameter[0];
    }

    public String getName(){
            return this.name;
    }

    public String getCategory(){
            return this.category;
    }

    public String getType(){
            return this.type;
    }

    public String getBoundTo(){
            return this.boundTo;
    }

    public boolean isAutoBindable(){
            return this.autoBindable;
    }

    public io.dekorate.halkyon.config.Parameter[] getParameters(){
            return this.parameters;
    }

    public static RequiredCapabilityConfigBuilder newRequiredCapabilityConfigBuilder(){
            return new io.dekorate.halkyon.config.RequiredCapabilityConfigBuilder();
    }




}
