package io.dekorate.halkyon.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import io.dekorate.kubernetes.config.ConfigKey;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import io.dekorate.kubernetes.config.ConfigurationFluent;
import java.lang.String;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import io.dekorate.project.Project;
import java.lang.StringBuffer;
import java.lang.Deprecated;
import java.util.Iterator;
import java.util.Collection;
import java.lang.Object;
import java.lang.Boolean;
import java.util.Map;

public interface RequiredCapabilityConfigFluent<A extends RequiredCapabilityConfigFluent<A>> extends ConfigurationFluent<A>{


    public String getName();
    public A withName(String name);
    public Boolean hasName();
    public A withNewName(String arg1);
    public A withNewName(StringBuilder arg1);
    public A withNewName(StringBuffer arg1);
    public String getCategory();
    public A withCategory(String category);
    public Boolean hasCategory();
    public A withNewCategory(String arg1);
    public A withNewCategory(StringBuilder arg1);
    public A withNewCategory(StringBuffer arg1);
    public String getType();
    public A withType(String type);
    public Boolean hasType();
    public A withNewType(String arg1);
    public A withNewType(StringBuilder arg1);
    public A withNewType(StringBuffer arg1);
    public String getBoundTo();
    public A withBoundTo(String boundTo);
    public Boolean hasBoundTo();
    public A withNewBoundTo(String arg1);
    public A withNewBoundTo(StringBuilder arg1);
    public A withNewBoundTo(StringBuffer arg1);
    public boolean isAutoBindable();
    public A withAutoBindable(boolean autoBindable);
    public Boolean hasAutoBindable();
    public A withParameters(io.dekorate.halkyon.config.Parameter... parameters);
    
/**
 * This method has been deprecated, please use method buildParameters instead.
 */
@Deprecated public io.dekorate.halkyon.config.Parameter[] getParameters();
    public io.dekorate.halkyon.config.Parameter[] buildParameters();
    public io.dekorate.halkyon.config.Parameter buildParameter(int index);
    public io.dekorate.halkyon.config.Parameter buildFirstParameter();
    public io.dekorate.halkyon.config.Parameter buildLastParameter();
    public io.dekorate.halkyon.config.Parameter buildMatchingParameter(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.halkyon.config.ParameterBuilder> predicate);
    public Boolean hasMatchingParameter(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.halkyon.config.ParameterBuilder> predicate);
    public A addToParameters(int index,io.dekorate.halkyon.config.Parameter item);
    public A setToParameters(int index,io.dekorate.halkyon.config.Parameter item);
    public A addToParameters(io.dekorate.halkyon.config.Parameter... items);
    public A addAllToParameters(Collection<io.dekorate.halkyon.config.Parameter> items);
    public A removeFromParameters(io.dekorate.halkyon.config.Parameter... items);
    public A removeAllFromParameters(Collection<io.dekorate.halkyon.config.Parameter> items);
    public A removeMatchingFromParameters(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.halkyon.config.ParameterBuilder> predicate);
    public Boolean hasParameters();
    public A addNewParameter(String name,String value);
    public RequiredCapabilityConfigFluent.ParametersNested<A> addNewParameter();
    public RequiredCapabilityConfigFluent.ParametersNested<A> addNewParameterLike(io.dekorate.halkyon.config.Parameter item);
    public RequiredCapabilityConfigFluent.ParametersNested<A> setNewParameterLike(int index,io.dekorate.halkyon.config.Parameter item);
    public RequiredCapabilityConfigFluent.ParametersNested<A> editParameter(int index);
    public RequiredCapabilityConfigFluent.ParametersNested<A> editFirstParameter();
    public RequiredCapabilityConfigFluent.ParametersNested<A> editLastParameter();
    public RequiredCapabilityConfigFluent.ParametersNested<A> editMatchingParameter(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.halkyon.config.ParameterBuilder> predicate);

    public interface ParametersNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,io.dekorate.halkyon.config.ParameterFluent<RequiredCapabilityConfigFluent.ParametersNested<N>>{

        
    public N and();    public N endParameter();
}


}
