/**
 * Copyright 2018 The original authors.
 * <p>
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * <p>
 * http://www.apache.org/licenses/LICENSE-2.0
 * <p>
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **/
package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.model.Doneable;
import io.sundr.builder.annotations.Buildable;
import io.sundr.builder.annotations.Inline;

@Buildable(editableEnabled = false, builderPackage = "io.dekorate.deps.kubernetes.api.builder", inline = @Inline(type = Doneable.class, prefix = "Doneable", value = "done"))
public class BuildConfig {
  private String type;
  private String url;
  private String ref = "master";
  private String contextPath = ".";
  private String moduleDirName = ".";
  
  public BuildConfig() {
  }
  
  public BuildConfig(String type, String url, String ref, String contextPath, String moduleDirName) {
    this.type = type;
    this.url = url;
    this.ref = ref;
    this.contextPath = contextPath;
    this.moduleDirName = moduleDirName;
  }
  
  public String getUrl() {
    return url;
  }
  
  public void setUrl(String url) {
    this.url = url;
  }
  
  public String getRef() {
    return ref;
  }
  
  public void setRef(String ref) {
    this.ref = ref;
  }
  
  public String getType() {
    return type;
  }
  
  public void setType(String type) {
    this.type = type;
  }
  
  public String getContextPath() {
    return contextPath;
  }
  
  public void setContextPath(String contextPath) {
    this.contextPath = contextPath;
  }
  
  public String getModuleDirName() {
    return moduleDirName;
  }
  
  public void setModuleDirName(String moduleDirName) {
    this.moduleDirName = moduleDirName;
  }
}
