package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class BuildConfigBuilder extends BuildConfigFluentImpl<BuildConfigBuilder> implements VisitableBuilder<BuildConfig,BuildConfigBuilder>{

    BuildConfigFluent<?> fluent;
    Boolean validationEnabled;

    public BuildConfigBuilder(){
            this(true);
    }
    public BuildConfigBuilder(Boolean validationEnabled){
            this(new BuildConfig(), validationEnabled);
    }
    public BuildConfigBuilder(BuildConfigFluent<?> fluent){
            this(fluent, true);
    }
    public BuildConfigBuilder(BuildConfigFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new BuildConfig(), validationEnabled);
    }
    public BuildConfigBuilder(BuildConfigFluent<?> fluent,BuildConfig instance){
            this(fluent, instance, true);
    }
    public BuildConfigBuilder(BuildConfigFluent<?> fluent,BuildConfig instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withType(instance.getType()); 
            fluent.withUrl(instance.getUrl()); 
            fluent.withRef(instance.getRef()); 
            fluent.withContextPath(instance.getContextPath()); 
            fluent.withModuleDirName(instance.getModuleDirName()); 
            this.validationEnabled = validationEnabled; 
    }
    public BuildConfigBuilder(BuildConfig instance){
            this(instance,true);
    }
    public BuildConfigBuilder(BuildConfig instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withType(instance.getType()); 
            this.withUrl(instance.getUrl()); 
            this.withRef(instance.getRef()); 
            this.withContextPath(instance.getContextPath()); 
            this.withModuleDirName(instance.getModuleDirName()); 
            this.validationEnabled = validationEnabled; 
    }

    public BuildConfig build(){
            BuildConfig buildable = new BuildConfig(fluent.getType(),fluent.getUrl(),fluent.getRef(),fluent.getContextPath(),fluent.getModuleDirName());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            BuildConfigBuilder that = (BuildConfigBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
