package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import io.dekorate.deps.kubernetes.api.builder.Fluent;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import java.lang.Deprecated;
import java.util.Iterator;
import java.util.Collection;
import java.lang.Boolean;

public interface CapabilitiesFluent<A extends CapabilitiesFluent<A>> extends Fluent<A>{


    public A withRequires(RequiredComponentCapability... requires);
    
/**
 * This method has been deprecated, please use method buildRequires instead.
 */
@Deprecated public RequiredComponentCapability[] getRequires();
    public RequiredComponentCapability[] buildRequires();
    public RequiredComponentCapability buildRequire(int index);
    public RequiredComponentCapability buildFirstRequire();
    public RequiredComponentCapability buildLastRequire();
    public RequiredComponentCapability buildMatchingRequire(io.dekorate.deps.kubernetes.api.builder.Predicate<RequiredComponentCapabilityBuilder> predicate);
    public Boolean hasMatchingRequire(io.dekorate.deps.kubernetes.api.builder.Predicate<RequiredComponentCapabilityBuilder> predicate);
    public A addToRequires(int index,RequiredComponentCapability item);
    public A setToRequires(int index,RequiredComponentCapability item);
    public A addToRequires(RequiredComponentCapability... items);
    public A addAllToRequires(Collection<RequiredComponentCapability> items);
    public A removeFromRequires(RequiredComponentCapability... items);
    public A removeAllFromRequires(Collection<RequiredComponentCapability> items);
    public A removeMatchingFromRequires(io.dekorate.deps.kubernetes.api.builder.Predicate<RequiredComponentCapabilityBuilder> predicate);
    public Boolean hasRequires();
    public CapabilitiesFluent.RequiresNested<A> addNewRequire();
    public CapabilitiesFluent.RequiresNested<A> addNewRequireLike(RequiredComponentCapability item);
    public CapabilitiesFluent.RequiresNested<A> setNewRequireLike(int index,RequiredComponentCapability item);
    public CapabilitiesFluent.RequiresNested<A> editRequire(int index);
    public CapabilitiesFluent.RequiresNested<A> editFirstRequire();
    public CapabilitiesFluent.RequiresNested<A> editLastRequire();
    public CapabilitiesFluent.RequiresNested<A> editMatchingRequire(io.dekorate.deps.kubernetes.api.builder.Predicate<RequiredComponentCapabilityBuilder> predicate);
    public A withProvides(ComponentCapability... provides);
    
/**
 * This method has been deprecated, please use method buildProvides instead.
 */
@Deprecated public ComponentCapability[] getProvides();
    public ComponentCapability[] buildProvides();
    public ComponentCapability buildProvide(int index);
    public ComponentCapability buildFirstProvide();
    public ComponentCapability buildLastProvide();
    public ComponentCapability buildMatchingProvide(io.dekorate.deps.kubernetes.api.builder.Predicate<ComponentCapabilityBuilder> predicate);
    public Boolean hasMatchingProvide(io.dekorate.deps.kubernetes.api.builder.Predicate<ComponentCapabilityBuilder> predicate);
    public A addToProvides(int index,ComponentCapability item);
    public A setToProvides(int index,ComponentCapability item);
    public A addToProvides(ComponentCapability... items);
    public A addAllToProvides(Collection<ComponentCapability> items);
    public A removeFromProvides(ComponentCapability... items);
    public A removeAllFromProvides(Collection<ComponentCapability> items);
    public A removeMatchingFromProvides(io.dekorate.deps.kubernetes.api.builder.Predicate<ComponentCapabilityBuilder> predicate);
    public Boolean hasProvides();
    public CapabilitiesFluent.ProvidesNested<A> addNewProvide();
    public CapabilitiesFluent.ProvidesNested<A> addNewProvideLike(ComponentCapability item);
    public CapabilitiesFluent.ProvidesNested<A> setNewProvideLike(int index,ComponentCapability item);
    public CapabilitiesFluent.ProvidesNested<A> editProvide(int index);
    public CapabilitiesFluent.ProvidesNested<A> editFirstProvide();
    public CapabilitiesFluent.ProvidesNested<A> editLastProvide();
    public CapabilitiesFluent.ProvidesNested<A> editMatchingProvide(io.dekorate.deps.kubernetes.api.builder.Predicate<ComponentCapabilityBuilder> predicate);

    public interface RequiresNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,RequiredComponentCapabilityFluent<CapabilitiesFluent.RequiresNested<N>>{

        
    public N and();    public N endRequire();
}
    public interface ProvidesNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,ComponentCapabilityFluent<CapabilitiesFluent.ProvidesNested<N>>{

        
    public N and();    public N endProvide();
}


}
