package io.dekorate.halkyon.model;

import java.util.HashMap;
import java.util.Map;

import io.dekorate.deps.jackson.annotation.JsonIgnore;
import io.dekorate.deps.jackson.annotation.JsonInclude;
import io.dekorate.deps.jackson.annotation.JsonProperty;
import io.dekorate.deps.jackson.annotation.JsonPropertyOrder;
import io.dekorate.deps.jackson.databind.annotation.JsonDeserialize;
import io.dekorate.deps.kubernetes.api.model.Doneable;
import io.dekorate.deps.kubernetes.api.model.HasMetadata;
import io.dekorate.deps.kubernetes.api.model.ObjectMeta;

import io.sundr.builder.annotations.Buildable;
import io.sundr.builder.annotations.BuildableReference;
import io.sundr.builder.annotations.Inline;



                              
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
"apiVersion",
"kind",
"metadata",
"spec",
"status"
})
@JsonDeserialize(using = io.dekorate.deps.jackson.databind.JsonDeserializer.None.class)
@Buildable(editableEnabled = false, validationEnabled = false, generateBuilderPackage = false, builderPackage = "io.dekorate.deps.kubernetes.api.builder", inline = @Inline(type = Doneable.class, prefix = "Doneable", value = "done"), refs = @BuildableReference(ObjectMeta.class))
public class Capability implements HasMetadata {

/**
* (Required)
*/
@JsonProperty("apiVersion")
private String apiVersion = "halkyon.io/v1beta1";
/**
* (Required)
*/
@JsonProperty("kind")
private String kind = "Capability";

/**
*
*/
@JsonProperty("metadata")
private ObjectMeta metadata;
/**
*
*/
@JsonProperty("spec")
private CapabilitySpec spec;

@JsonProperty("status")
private CapabilityStatus status;

/**
* No args constructor for use in serialization
*/
public Capability() {
}

/**
* @param metadata
* @param apiVersion
* @param kind
* @param spec
*/
public Capability(String apiVersion, String kind, ObjectMeta metadata, CapabilitySpec spec, CapabilityStatus status) {
this.apiVersion = apiVersion;
this.kind = kind;
this.metadata = metadata;
this.spec = spec;
this.status = status;
}

/**
* (Required)
*
* @return The apiVersion
*/
@JsonProperty("apiVersion")
public String getApiVersion() {
return apiVersion;
}

/**
* (Required)
*
* @param apiVersion The apiVersion
*/
@JsonProperty("apiVersion")
public void setApiVersion(String apiVersion) {
this.apiVersion = apiVersion;
}

/**
* (Required)
*
* @return The kind
*/
@JsonProperty("kind")
public String getKind() {
return kind;
}

/**
* (Required)
*
* @param kind The kind
*/
@JsonProperty("kind")
public void setKind(String kind) {
this.kind = kind;
}

/**
* @return The metadata
*/
@JsonProperty("metadata")
public ObjectMeta getMetadata() {
return metadata;
}

/**
* @param metadata The metadata
*/
@JsonProperty("metadata")
public void setMetadata(ObjectMeta metadata) {
this.metadata = metadata;
}

/**
* @return The spec
*/
@JsonProperty("spec")
public CapabilitySpec getSpec() {
return spec;
}

/**
* @param spec The spec
*/
@JsonProperty("spec")
public void setSpec(CapabilitySpec spec) {
this.spec = spec;
}

@JsonProperty("status")
public CapabilityStatus getStatus() {
return status;
}

public void setStatus(CapabilityStatus status) {
this.status = status;
}

}
