package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class CapabilityBuilder extends CapabilityFluentImpl<CapabilityBuilder> implements VisitableBuilder<Capability,CapabilityBuilder>{

    CapabilityFluent<?> fluent;
    Boolean validationEnabled;

    public CapabilityBuilder(){
            this(true);
    }
    public CapabilityBuilder(Boolean validationEnabled){
            this(new Capability(), validationEnabled);
    }
    public CapabilityBuilder(CapabilityFluent<?> fluent){
            this(fluent, true);
    }
    public CapabilityBuilder(CapabilityFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new Capability(), validationEnabled);
    }
    public CapabilityBuilder(CapabilityFluent<?> fluent,Capability instance){
            this(fluent, instance, true);
    }
    public CapabilityBuilder(CapabilityFluent<?> fluent,Capability instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withApiVersion(instance.getApiVersion()); 
            fluent.withKind(instance.getKind()); 
            fluent.withMetadata(instance.getMetadata()); 
            fluent.withSpec(instance.getSpec()); 
            fluent.withStatus(instance.getStatus()); 
            this.validationEnabled = validationEnabled; 
    }
    public CapabilityBuilder(Capability instance){
            this(instance,true);
    }
    public CapabilityBuilder(Capability instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withApiVersion(instance.getApiVersion()); 
            this.withKind(instance.getKind()); 
            this.withMetadata(instance.getMetadata()); 
            this.withSpec(instance.getSpec()); 
            this.withStatus(instance.getStatus()); 
            this.validationEnabled = validationEnabled; 
    }

    public Capability build(){
            Capability buildable = new Capability(fluent.getApiVersion(),fluent.getKind(),fluent.getMetadata(),fluent.getSpec(),fluent.getStatus());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            CapabilityBuilder that = (CapabilityBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
