package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.model.ObjectMeta;
import io.dekorate.deps.jackson.annotation.JsonProperty;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Fluent;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.lang.String;
import io.dekorate.deps.kubernetes.api.model.ObjectMetaBuilder;
import java.lang.StringBuffer;
import io.dekorate.deps.kubernetes.api.model.ObjectMetaFluent;
import java.lang.Deprecated;
import java.lang.Boolean;

public interface CapabilityFluent<A extends CapabilityFluent<A>> extends Fluent<A>{


    public String getApiVersion();
    public A withApiVersion(String apiVersion);
    public Boolean hasApiVersion();
    public A withNewApiVersion(String arg1);
    public A withNewApiVersion(StringBuilder arg1);
    public A withNewApiVersion(StringBuffer arg1);
    public String getKind();
    public A withKind(String kind);
    public Boolean hasKind();
    public A withNewKind(String arg1);
    public A withNewKind(StringBuilder arg1);
    public A withNewKind(StringBuffer arg1);
    
/**
 * This method has been deprecated, please use method buildMetadata instead.
 * @return The buildable object.
 */
@Deprecated public ObjectMeta getMetadata();
    public ObjectMeta buildMetadata();
    public A withMetadata(ObjectMeta metadata);
    public Boolean hasMetadata();
    public CapabilityFluent.MetadataNested<A> withNewMetadata();
    public CapabilityFluent.MetadataNested<A> withNewMetadataLike(ObjectMeta item);
    public CapabilityFluent.MetadataNested<A> editMetadata();
    public CapabilityFluent.MetadataNested<A> editOrNewMetadata();
    public CapabilityFluent.MetadataNested<A> editOrNewMetadataLike(ObjectMeta item);
    
/**
 * This method has been deprecated, please use method buildSpec instead.
 * @return The buildable object.
 */
@Deprecated public CapabilitySpec getSpec();
    public CapabilitySpec buildSpec();
    public A withSpec(CapabilitySpec spec);
    public Boolean hasSpec();
    public io.dekorate.halkyon.model.CapabilityFluent.SpecNested<A> withNewSpec();
    public io.dekorate.halkyon.model.CapabilityFluent.SpecNested<A> withNewSpecLike(CapabilitySpec item);
    public io.dekorate.halkyon.model.CapabilityFluent.SpecNested<A> editSpec();
    public io.dekorate.halkyon.model.CapabilityFluent.SpecNested<A> editOrNewSpec();
    public io.dekorate.halkyon.model.CapabilityFluent.SpecNested<A> editOrNewSpecLike(CapabilitySpec item);
    
/**
 * This method has been deprecated, please use method buildStatus instead.
 * @return The buildable object.
 */
@Deprecated public CapabilityStatus getStatus();
    public CapabilityStatus buildStatus();
    public A withStatus(CapabilityStatus status);
    public Boolean hasStatus();
    public A withNewStatus(String phase);
    public CapabilityFluent.StatusNested<A> withNewStatus();
    public CapabilityFluent.StatusNested<A> withNewStatusLike(CapabilityStatus item);
    public CapabilityFluent.StatusNested<A> editStatus();
    public CapabilityFluent.StatusNested<A> editOrNewStatus();
    public CapabilityFluent.StatusNested<A> editOrNewStatusLike(CapabilityStatus item);

    public interface MetadataNested<N> extends Nested<N>,ObjectMetaFluent<CapabilityFluent.MetadataNested<N>>{

        
    public N and();    public N endMetadata();
}
    public interface SpecNested<N> extends Nested<N>,CapabilitySpecFluent<io.dekorate.halkyon.model.CapabilityFluent.SpecNested<N>>{

        
    public N and();    public N endSpec();
}
    public interface StatusNested<N> extends Nested<N>,CapabilityStatusFluent<CapabilityFluent.StatusNested<N>>{

        
    public N and();    public N endStatus();
}


}
