package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class CapabilityListBuilder extends CapabilityListFluentImpl<CapabilityListBuilder> implements VisitableBuilder<CapabilityList,CapabilityListBuilder>{

    CapabilityListFluent<?> fluent;
    Boolean validationEnabled;

    public CapabilityListBuilder(){
            this(true);
    }
    public CapabilityListBuilder(Boolean validationEnabled){
            this(new CapabilityList(), validationEnabled);
    }
    public CapabilityListBuilder(CapabilityListFluent<?> fluent){
            this(fluent, true);
    }
    public CapabilityListBuilder(CapabilityListFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new CapabilityList(), validationEnabled);
    }
    public CapabilityListBuilder(CapabilityListFluent<?> fluent,CapabilityList instance){
            this(fluent, instance, true);
    }
    public CapabilityListBuilder(CapabilityListFluent<?> fluent,CapabilityList instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withApiVersion(instance.getApiVersion()); 
            fluent.withItems(instance.getItems()); 
            fluent.withKind(instance.getKind()); 
            fluent.withMetadata(instance.getMetadata()); 
            this.validationEnabled = validationEnabled; 
    }
    public CapabilityListBuilder(CapabilityList instance){
            this(instance,true);
    }
    public CapabilityListBuilder(CapabilityList instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withApiVersion(instance.getApiVersion()); 
            this.withItems(instance.getItems()); 
            this.withKind(instance.getKind()); 
            this.withMetadata(instance.getMetadata()); 
            this.validationEnabled = validationEnabled; 
    }

    public CapabilityList build(){
            CapabilityList buildable = new CapabilityList(fluent.getApiVersion(),fluent.getItems(),fluent.getKind(),fluent.getMetadata());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            CapabilityListBuilder that = (CapabilityListBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
