package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import io.dekorate.deps.jackson.annotation.JsonProperty;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Fluent;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import io.dekorate.deps.kubernetes.api.model.ListMeta;
import java.lang.StringBuffer;
import java.lang.Deprecated;
import java.lang.Long;
import java.util.Iterator;
import java.util.Collection;
import java.util.List;
import java.lang.Boolean;

public interface CapabilityListFluent<A extends CapabilityListFluent<A>> extends Fluent<A>{


    public String getApiVersion();
    public A withApiVersion(String apiVersion);
    public Boolean hasApiVersion();
    public A withNewApiVersion(String arg1);
    public A withNewApiVersion(StringBuilder arg1);
    public A withNewApiVersion(StringBuffer arg1);
    public A addToItems(int index,Capability item);
    public A setToItems(int index,Capability item);
    public A addToItems(Capability... items);
    public A addAllToItems(Collection<Capability> items);
    public A removeFromItems(Capability... items);
    public A removeAllFromItems(Collection<Capability> items);
    public A removeMatchingFromItems(Predicate<CapabilityBuilder> predicate);
    
/**
 * This method has been deprecated, please use method buildItems instead.
 * @return The buildable object.
 */
@Deprecated public List<Capability> getItems();
    public List<Capability> buildItems();
    public Capability buildItem(int index);
    public Capability buildFirstItem();
    public Capability buildLastItem();
    public Capability buildMatchingItem(Predicate<CapabilityBuilder> predicate);
    public Boolean hasMatchingItem(Predicate<CapabilityBuilder> predicate);
    public A withItems(List<Capability> items);
    public A withItems(Capability... items);
    public Boolean hasItems();
    public CapabilityListFluent.ItemsNested<A> addNewItem();
    public CapabilityListFluent.ItemsNested<A> addNewItemLike(Capability item);
    public CapabilityListFluent.ItemsNested<A> setNewItemLike(int index,Capability item);
    public CapabilityListFluent.ItemsNested<A> editItem(int index);
    public CapabilityListFluent.ItemsNested<A> editFirstItem();
    public CapabilityListFluent.ItemsNested<A> editLastItem();
    public CapabilityListFluent.ItemsNested<A> editMatchingItem(Predicate<CapabilityBuilder> predicate);
    public String getKind();
    public A withKind(String kind);
    public Boolean hasKind();
    public A withNewKind(String arg1);
    public A withNewKind(StringBuilder arg1);
    public A withNewKind(StringBuffer arg1);
    public ListMeta getMetadata();
    public A withMetadata(ListMeta metadata);
    public Boolean hasMetadata();
    public A withNewMetadata(String _continue,Long remainingItemCount,String resourceVersion,String selfLink);

    public interface ItemsNested<N> extends Nested<N>,CapabilityFluent<CapabilityListFluent.ItemsNested<N>>{

        
    public N and();    public N endItem();
}


}
