package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class CapabilityStatusBuilder extends CapabilityStatusFluentImpl<CapabilityStatusBuilder> implements VisitableBuilder<CapabilityStatus,CapabilityStatusBuilder>{

    CapabilityStatusFluent<?> fluent;
    Boolean validationEnabled;

    public CapabilityStatusBuilder(){
            this(true);
    }
    public CapabilityStatusBuilder(Boolean validationEnabled){
            this(new CapabilityStatus(), validationEnabled);
    }
    public CapabilityStatusBuilder(CapabilityStatusFluent<?> fluent){
            this(fluent, true);
    }
    public CapabilityStatusBuilder(CapabilityStatusFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new CapabilityStatus(), validationEnabled);
    }
    public CapabilityStatusBuilder(CapabilityStatusFluent<?> fluent,CapabilityStatus instance){
            this(fluent, instance, true);
    }
    public CapabilityStatusBuilder(CapabilityStatusFluent<?> fluent,CapabilityStatus instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withPhase(instance.getPhase()); 
            this.validationEnabled = validationEnabled; 
    }
    public CapabilityStatusBuilder(CapabilityStatus instance){
            this(instance,true);
    }
    public CapabilityStatusBuilder(CapabilityStatus instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withPhase(instance.getPhase()); 
            this.validationEnabled = validationEnabled; 
    }

    public CapabilityStatus build(){
            CapabilityStatus buildable = new CapabilityStatus(fluent.getPhase());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            CapabilityStatusBuilder that = (CapabilityStatusBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
