package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class ComponentBuilder extends ComponentFluentImpl<ComponentBuilder> implements VisitableBuilder<Component,ComponentBuilder>{

    ComponentFluent<?> fluent;
    Boolean validationEnabled;

    public ComponentBuilder(){
            this(true);
    }
    public ComponentBuilder(Boolean validationEnabled){
            this(new Component(), validationEnabled);
    }
    public ComponentBuilder(ComponentFluent<?> fluent){
            this(fluent, true);
    }
    public ComponentBuilder(ComponentFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new Component(), validationEnabled);
    }
    public ComponentBuilder(ComponentFluent<?> fluent,Component instance){
            this(fluent, instance, true);
    }
    public ComponentBuilder(ComponentFluent<?> fluent,Component instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withApiVersion(instance.getApiVersion()); 
            fluent.withKind(instance.getKind()); 
            fluent.withMetadata(instance.getMetadata()); 
            fluent.withSpec(instance.getSpec()); 
            fluent.withStatus(instance.getStatus()); 
            this.validationEnabled = validationEnabled; 
    }
    public ComponentBuilder(Component instance){
            this(instance,true);
    }
    public ComponentBuilder(Component instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withApiVersion(instance.getApiVersion()); 
            this.withKind(instance.getKind()); 
            this.withMetadata(instance.getMetadata()); 
            this.withSpec(instance.getSpec()); 
            this.withStatus(instance.getStatus()); 
            this.validationEnabled = validationEnabled; 
    }

    public Component build(){
            Component buildable = new Component(fluent.getApiVersion(),fluent.getKind(),fluent.getMetadata(),fluent.getSpec(),fluent.getStatus());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            ComponentBuilder that = (ComponentBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
