package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Fluent;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import java.lang.StringBuffer;
import java.lang.Deprecated;
import java.util.Iterator;
import java.util.Collection;
import java.lang.Boolean;

public interface ComponentCapabilityFluent<A extends ComponentCapabilityFluent<A>> extends Fluent<A>{


    public String getName();
    public A withName(String name);
    public Boolean hasName();
    public A withNewName(String arg1);
    public A withNewName(StringBuilder arg1);
    public A withNewName(StringBuffer arg1);
    
/**
 * This method has been deprecated, please use method buildSpec instead.
 * @return The buildable object.
 */
@Deprecated public CapabilitySpec getSpec();
    public CapabilitySpec buildSpec();
    public A withSpec(CapabilitySpec spec);
    public Boolean hasSpec();
    public ComponentCapabilityFluent.SpecNested<A> withNewSpec();
    public ComponentCapabilityFluent.SpecNested<A> withNewSpecLike(CapabilitySpec item);
    public ComponentCapabilityFluent.SpecNested<A> editSpec();
    public ComponentCapabilityFluent.SpecNested<A> editOrNewSpec();
    public ComponentCapabilityFluent.SpecNested<A> editOrNewSpecLike(CapabilitySpec item);
    public A withParameters(io.dekorate.halkyon.model.Parameter... parameters);
    
/**
 * This method has been deprecated, please use method buildParameters instead.
 */
@Deprecated public io.dekorate.halkyon.model.Parameter[] getParameters();
    public io.dekorate.halkyon.model.Parameter[] buildParameters();
    public io.dekorate.halkyon.model.Parameter buildParameter(int index);
    public io.dekorate.halkyon.model.Parameter buildFirstParameter();
    public io.dekorate.halkyon.model.Parameter buildLastParameter();
    public io.dekorate.halkyon.model.Parameter buildMatchingParameter(io.dekorate.deps.kubernetes.api.builder.Predicate<ParameterBuilder> predicate);
    public Boolean hasMatchingParameter(io.dekorate.deps.kubernetes.api.builder.Predicate<ParameterBuilder> predicate);
    public A addToParameters(int index,io.dekorate.halkyon.model.Parameter item);
    public A setToParameters(int index,io.dekorate.halkyon.model.Parameter item);
    public A addToParameters(io.dekorate.halkyon.model.Parameter... items);
    public A addAllToParameters(Collection<io.dekorate.halkyon.model.Parameter> items);
    public A removeFromParameters(io.dekorate.halkyon.model.Parameter... items);
    public A removeAllFromParameters(Collection<io.dekorate.halkyon.model.Parameter> items);
    public A removeMatchingFromParameters(io.dekorate.deps.kubernetes.api.builder.Predicate<ParameterBuilder> predicate);
    public Boolean hasParameters();
    public A addNewParameter(String name,String value);
    public ComponentCapabilityFluent.ParametersNested<A> addNewParameter();
    public ComponentCapabilityFluent.ParametersNested<A> addNewParameterLike(io.dekorate.halkyon.model.Parameter item);
    public ComponentCapabilityFluent.ParametersNested<A> setNewParameterLike(int index,io.dekorate.halkyon.model.Parameter item);
    public ComponentCapabilityFluent.ParametersNested<A> editParameter(int index);
    public ComponentCapabilityFluent.ParametersNested<A> editFirstParameter();
    public ComponentCapabilityFluent.ParametersNested<A> editLastParameter();
    public ComponentCapabilityFluent.ParametersNested<A> editMatchingParameter(io.dekorate.deps.kubernetes.api.builder.Predicate<ParameterBuilder> predicate);

    public interface SpecNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,CapabilitySpecFluent<ComponentCapabilityFluent.SpecNested<N>>{

        
    public N and();    public N endSpec();
}
    public interface ParametersNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,ParameterFluent<ComponentCapabilityFluent.ParametersNested<N>>{

        
    public N and();    public N endParameter();
}


}
