package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.model.ObjectMeta;
import io.dekorate.deps.jackson.annotation.JsonProperty;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Fluent;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.lang.String;
import io.dekorate.deps.kubernetes.api.model.ObjectMetaBuilder;
import java.lang.StringBuffer;
import io.dekorate.deps.kubernetes.api.model.ObjectMetaFluent;
import java.lang.Deprecated;
import java.lang.Boolean;

public interface ComponentFluent<A extends ComponentFluent<A>> extends Fluent<A>{


    public String getApiVersion();
    public A withApiVersion(String apiVersion);
    public Boolean hasApiVersion();
    public A withNewApiVersion(String arg1);
    public A withNewApiVersion(StringBuilder arg1);
    public A withNewApiVersion(StringBuffer arg1);
    public String getKind();
    public A withKind(String kind);
    public Boolean hasKind();
    public A withNewKind(String arg1);
    public A withNewKind(StringBuilder arg1);
    public A withNewKind(StringBuffer arg1);
    
/**
 * This method has been deprecated, please use method buildMetadata instead.
 * @return The buildable object.
 */
@Deprecated public ObjectMeta getMetadata();
    public ObjectMeta buildMetadata();
    public A withMetadata(ObjectMeta metadata);
    public Boolean hasMetadata();
    public ComponentFluent.MetadataNested<A> withNewMetadata();
    public ComponentFluent.MetadataNested<A> withNewMetadataLike(ObjectMeta item);
    public ComponentFluent.MetadataNested<A> editMetadata();
    public ComponentFluent.MetadataNested<A> editOrNewMetadata();
    public ComponentFluent.MetadataNested<A> editOrNewMetadataLike(ObjectMeta item);
    
/**
 * This method has been deprecated, please use method buildSpec instead.
 * @return The buildable object.
 */
@Deprecated public ComponentSpec getSpec();
    public ComponentSpec buildSpec();
    public A withSpec(ComponentSpec spec);
    public Boolean hasSpec();
    public io.dekorate.halkyon.model.ComponentFluent.SpecNested<A> withNewSpec();
    public io.dekorate.halkyon.model.ComponentFluent.SpecNested<A> withNewSpecLike(ComponentSpec item);
    public io.dekorate.halkyon.model.ComponentFluent.SpecNested<A> editSpec();
    public io.dekorate.halkyon.model.ComponentFluent.SpecNested<A> editOrNewSpec();
    public io.dekorate.halkyon.model.ComponentFluent.SpecNested<A> editOrNewSpecLike(ComponentSpec item);
    
/**
 * This method has been deprecated, please use method buildStatus instead.
 * @return The buildable object.
 */
@Deprecated public ComponentStatus getStatus();
    public ComponentStatus buildStatus();
    public A withStatus(ComponentStatus status);
    public Boolean hasStatus();
    public A withNewStatus(String phase);
    public ComponentFluent.StatusNested<A> withNewStatus();
    public ComponentFluent.StatusNested<A> withNewStatusLike(ComponentStatus item);
    public ComponentFluent.StatusNested<A> editStatus();
    public ComponentFluent.StatusNested<A> editOrNewStatus();
    public ComponentFluent.StatusNested<A> editOrNewStatusLike(ComponentStatus item);

    public interface MetadataNested<N> extends Nested<N>,ObjectMetaFluent<ComponentFluent.MetadataNested<N>>{

        
    public N and();    public N endMetadata();
}
    public interface SpecNested<N> extends Nested<N>,ComponentSpecFluent<io.dekorate.halkyon.model.ComponentFluent.SpecNested<N>>{

        
    public N and();    public N endSpec();
}
    public interface StatusNested<N> extends Nested<N>,ComponentStatusFluent<ComponentFluent.StatusNested<N>>{

        
    public N and();    public N endStatus();
}


}
