package io.dekorate.halkyon.model;

import io.dekorate.deps.jackson.annotation.JsonProperty;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.lang.String;
import java.lang.Deprecated;
import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.lang.Boolean;
import io.dekorate.deps.kubernetes.api.model.ObjectMeta;
import io.dekorate.deps.kubernetes.api.model.ObjectMetaFluentImpl;
import io.dekorate.deps.kubernetes.api.model.ObjectMetaBuilder;
import java.lang.StringBuffer;
import java.lang.Object;

public class ComponentFluentImpl<A extends ComponentFluent<A>> extends BaseFluent<A> implements ComponentFluent<A>{

    private String apiVersion;
    private String kind;
    private ObjectMetaBuilder metadata;
    private ComponentSpecBuilder spec;
    private ComponentStatusBuilder status;

    public ComponentFluentImpl(){
    }
    public ComponentFluentImpl(Component instance){
            this.withApiVersion(instance.getApiVersion()); 
            this.withKind(instance.getKind()); 
            this.withMetadata(instance.getMetadata()); 
            this.withSpec(instance.getSpec()); 
            this.withStatus(instance.getStatus()); 
    }

    public String getApiVersion(){
            return this.apiVersion;
    }

    public A withApiVersion(String apiVersion){
            this.apiVersion=apiVersion; return (A) this;
    }

    public Boolean hasApiVersion(){
            return this.apiVersion != null;
    }

    public A withNewApiVersion(String arg1){
            return (A)withApiVersion(new String(arg1));
    }

    public A withNewApiVersion(StringBuilder arg1){
            return (A)withApiVersion(new String(arg1));
    }

    public A withNewApiVersion(StringBuffer arg1){
            return (A)withApiVersion(new String(arg1));
    }

    public String getKind(){
            return this.kind;
    }

    public A withKind(String kind){
            this.kind=kind; return (A) this;
    }

    public Boolean hasKind(){
            return this.kind != null;
    }

    public A withNewKind(String arg1){
            return (A)withKind(new String(arg1));
    }

    public A withNewKind(StringBuilder arg1){
            return (A)withKind(new String(arg1));
    }

    public A withNewKind(StringBuffer arg1){
            return (A)withKind(new String(arg1));
    }

    
/**
 * This method has been deprecated, please use method buildMetadata instead.
 * @return The buildable object.
 */
@Deprecated public ObjectMeta getMetadata(){
            return this.metadata!=null?this.metadata.build():null;
    }

    public ObjectMeta buildMetadata(){
            return this.metadata!=null?this.metadata.build():null;
    }

    public A withMetadata(ObjectMeta metadata){
            _visitables.get("metadata").remove(this.metadata);
            if (metadata!=null){ this.metadata= new ObjectMetaBuilder(metadata); _visitables.get("metadata").add(this.metadata);} return (A) this;
    }

    public Boolean hasMetadata(){
            return this.metadata != null;
    }

    public ComponentFluent.MetadataNested<A> withNewMetadata(){
            return new MetadataNestedImpl();
    }

    public ComponentFluent.MetadataNested<A> withNewMetadataLike(ObjectMeta item){
            return new MetadataNestedImpl(item);
    }

    public ComponentFluent.MetadataNested<A> editMetadata(){
            return withNewMetadataLike(getMetadata());
    }

    public ComponentFluent.MetadataNested<A> editOrNewMetadata(){
            return withNewMetadataLike(getMetadata() != null ? getMetadata(): new ObjectMetaBuilder().build());
    }

    public ComponentFluent.MetadataNested<A> editOrNewMetadataLike(ObjectMeta item){
            return withNewMetadataLike(getMetadata() != null ? getMetadata(): item);
    }

    
/**
 * This method has been deprecated, please use method buildSpec instead.
 * @return The buildable object.
 */
@Deprecated public ComponentSpec getSpec(){
            return this.spec!=null?this.spec.build():null;
    }

    public ComponentSpec buildSpec(){
            return this.spec!=null?this.spec.build():null;
    }

    public A withSpec(ComponentSpec spec){
            _visitables.get("spec").remove(this.spec);
            if (spec!=null){ this.spec= new ComponentSpecBuilder(spec); _visitables.get("spec").add(this.spec);} return (A) this;
    }

    public Boolean hasSpec(){
            return this.spec != null;
    }

    public io.dekorate.halkyon.model.ComponentFluent.SpecNested<A> withNewSpec(){
            return new io.dekorate.halkyon.model.ComponentFluentImpl.SpecNestedImpl();
    }

    public io.dekorate.halkyon.model.ComponentFluent.SpecNested<A> withNewSpecLike(ComponentSpec item){
            return new io.dekorate.halkyon.model.ComponentFluentImpl.SpecNestedImpl(item);
    }

    public io.dekorate.halkyon.model.ComponentFluent.SpecNested<A> editSpec(){
            return withNewSpecLike(getSpec());
    }

    public io.dekorate.halkyon.model.ComponentFluent.SpecNested<A> editOrNewSpec(){
            return withNewSpecLike(getSpec() != null ? getSpec(): new ComponentSpecBuilder().build());
    }

    public io.dekorate.halkyon.model.ComponentFluent.SpecNested<A> editOrNewSpecLike(ComponentSpec item){
            return withNewSpecLike(getSpec() != null ? getSpec(): item);
    }

    
/**
 * This method has been deprecated, please use method buildStatus instead.
 * @return The buildable object.
 */
@Deprecated public ComponentStatus getStatus(){
            return this.status!=null?this.status.build():null;
    }

    public ComponentStatus buildStatus(){
            return this.status!=null?this.status.build():null;
    }

    public A withStatus(ComponentStatus status){
            _visitables.get("status").remove(this.status);
            if (status!=null){ this.status= new ComponentStatusBuilder(status); _visitables.get("status").add(this.status);} return (A) this;
    }

    public Boolean hasStatus(){
            return this.status != null;
    }

    public A withNewStatus(String phase){
            return (A)withStatus(new ComponentStatus(phase));
    }

    public ComponentFluent.StatusNested<A> withNewStatus(){
            return new StatusNestedImpl();
    }

    public ComponentFluent.StatusNested<A> withNewStatusLike(ComponentStatus item){
            return new StatusNestedImpl(item);
    }

    public ComponentFluent.StatusNested<A> editStatus(){
            return withNewStatusLike(getStatus());
    }

    public ComponentFluent.StatusNested<A> editOrNewStatus(){
            return withNewStatusLike(getStatus() != null ? getStatus(): new ComponentStatusBuilder().build());
    }

    public ComponentFluent.StatusNested<A> editOrNewStatusLike(ComponentStatus item){
            return withNewStatusLike(getStatus() != null ? getStatus(): item);
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            ComponentFluentImpl that = (ComponentFluentImpl) o;
            if (apiVersion != null ? !apiVersion.equals(that.apiVersion) :that.apiVersion != null) return false;
            if (kind != null ? !kind.equals(that.kind) :that.kind != null) return false;
            if (metadata != null ? !metadata.equals(that.metadata) :that.metadata != null) return false;
            if (spec != null ? !spec.equals(that.spec) :that.spec != null) return false;
            if (status != null ? !status.equals(that.status) :that.status != null) return false;
            return true;
    }


    public class MetadataNestedImpl<N> extends ObjectMetaFluentImpl<ComponentFluent.MetadataNested<N>> implements ComponentFluent.MetadataNested<N>,Nested<N>{

            private final ObjectMetaBuilder builder;
    
            MetadataNestedImpl(ObjectMeta item){
                    this.builder = new ObjectMetaBuilder(this, item);
            }
            MetadataNestedImpl(){
                    this.builder = new ObjectMetaBuilder(this);
            }
    
    public N and(){
            return (N) ComponentFluentImpl.this.withMetadata(builder.build());
    }
    public N endMetadata(){
            return and();
    }

}
    public class SpecNestedImpl<N> extends ComponentSpecFluentImpl<io.dekorate.halkyon.model.ComponentFluent.SpecNested<N>> implements io.dekorate.halkyon.model.ComponentFluent.SpecNested<N>,Nested<N>{

            private final ComponentSpecBuilder builder;
    
            SpecNestedImpl(ComponentSpec item){
                    this.builder = new ComponentSpecBuilder(this, item);
            }
            SpecNestedImpl(){
                    this.builder = new ComponentSpecBuilder(this);
            }
    
    public N and(){
            return (N) ComponentFluentImpl.this.withSpec(builder.build());
    }
    public N endSpec(){
            return and();
    }

}
    public class StatusNestedImpl<N> extends ComponentStatusFluentImpl<ComponentFluent.StatusNested<N>> implements ComponentFluent.StatusNested<N>,Nested<N>{

            private final ComponentStatusBuilder builder;
    
            StatusNestedImpl(ComponentStatus item){
                    this.builder = new ComponentStatusBuilder(this, item);
            }
            StatusNestedImpl(){
                    this.builder = new ComponentStatusBuilder(this);
            }
    
    public N and(){
            return (N) ComponentFluentImpl.this.withStatus(builder.build());
    }
    public N endStatus(){
            return and();
    }

}


}
