package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class ComponentListBuilder extends ComponentListFluentImpl<ComponentListBuilder> implements VisitableBuilder<ComponentList,ComponentListBuilder>{

    ComponentListFluent<?> fluent;
    Boolean validationEnabled;

    public ComponentListBuilder(){
            this(true);
    }
    public ComponentListBuilder(Boolean validationEnabled){
            this(new ComponentList(), validationEnabled);
    }
    public ComponentListBuilder(ComponentListFluent<?> fluent){
            this(fluent, true);
    }
    public ComponentListBuilder(ComponentListFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new ComponentList(), validationEnabled);
    }
    public ComponentListBuilder(ComponentListFluent<?> fluent,ComponentList instance){
            this(fluent, instance, true);
    }
    public ComponentListBuilder(ComponentListFluent<?> fluent,ComponentList instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withApiVersion(instance.getApiVersion()); 
            fluent.withItems(instance.getItems()); 
            fluent.withKind(instance.getKind()); 
            fluent.withMetadata(instance.getMetadata()); 
            this.validationEnabled = validationEnabled; 
    }
    public ComponentListBuilder(ComponentList instance){
            this(instance,true);
    }
    public ComponentListBuilder(ComponentList instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withApiVersion(instance.getApiVersion()); 
            this.withItems(instance.getItems()); 
            this.withKind(instance.getKind()); 
            this.withMetadata(instance.getMetadata()); 
            this.validationEnabled = validationEnabled; 
    }

    public ComponentList build(){
            ComponentList buildable = new ComponentList(fluent.getApiVersion(),fluent.getItems(),fluent.getKind(),fluent.getMetadata());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            ComponentListBuilder that = (ComponentListBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
