package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import io.dekorate.deps.jackson.annotation.JsonProperty;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Fluent;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import io.dekorate.deps.kubernetes.api.model.ListMeta;
import java.lang.StringBuffer;
import java.lang.Deprecated;
import java.lang.Long;
import java.util.Iterator;
import java.util.Collection;
import java.util.List;
import java.lang.Boolean;

public interface ComponentListFluent<A extends ComponentListFluent<A>> extends Fluent<A>{


    public String getApiVersion();
    public A withApiVersion(String apiVersion);
    public Boolean hasApiVersion();
    public A withNewApiVersion(String arg1);
    public A withNewApiVersion(StringBuilder arg1);
    public A withNewApiVersion(StringBuffer arg1);
    public A addToItems(int index,Component item);
    public A setToItems(int index,Component item);
    public A addToItems(Component... items);
    public A addAllToItems(Collection<Component> items);
    public A removeFromItems(Component... items);
    public A removeAllFromItems(Collection<Component> items);
    public A removeMatchingFromItems(Predicate<ComponentBuilder> predicate);
    
/**
 * This method has been deprecated, please use method buildItems instead.
 * @return The buildable object.
 */
@Deprecated public List<Component> getItems();
    public List<Component> buildItems();
    public Component buildItem(int index);
    public Component buildFirstItem();
    public Component buildLastItem();
    public Component buildMatchingItem(Predicate<ComponentBuilder> predicate);
    public Boolean hasMatchingItem(Predicate<ComponentBuilder> predicate);
    public A withItems(List<Component> items);
    public A withItems(Component... items);
    public Boolean hasItems();
    public ComponentListFluent.ItemsNested<A> addNewItem();
    public ComponentListFluent.ItemsNested<A> addNewItemLike(Component item);
    public ComponentListFluent.ItemsNested<A> setNewItemLike(int index,Component item);
    public ComponentListFluent.ItemsNested<A> editItem(int index);
    public ComponentListFluent.ItemsNested<A> editFirstItem();
    public ComponentListFluent.ItemsNested<A> editLastItem();
    public ComponentListFluent.ItemsNested<A> editMatchingItem(Predicate<ComponentBuilder> predicate);
    public String getKind();
    public A withKind(String kind);
    public Boolean hasKind();
    public A withNewKind(String arg1);
    public A withNewKind(StringBuilder arg1);
    public A withNewKind(StringBuffer arg1);
    public ListMeta getMetadata();
    public A withMetadata(ListMeta metadata);
    public Boolean hasMetadata();
    public A withNewMetadata(String _continue,Long remainingItemCount,String resourceVersion,String selfLink);

    public interface ItemsNested<N> extends Nested<N>,ComponentFluent<ComponentListFluent.ItemsNested<N>>{

        
    public N and();    public N endItem();
}


}
