package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import java.lang.String;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import java.lang.Deprecated;
import java.util.Iterator;
import java.lang.Boolean;
import io.dekorate.deps.kubernetes.api.builder.Fluent;
import java.lang.Integer;
import java.lang.StringBuffer;
import java.util.Collection;

public interface ComponentSpecFluent<A extends ComponentSpecFluent<A>> extends Fluent<A>{


    public DeploymentMode getDeploymentMode();
    public A withDeploymentMode(DeploymentMode deploymentMode);
    public Boolean hasDeploymentMode();
    public String getRuntime();
    public A withRuntime(String runtime);
    public Boolean hasRuntime();
    public A withNewRuntime(String arg1);
    public A withNewRuntime(StringBuilder arg1);
    public A withNewRuntime(StringBuffer arg1);
    public String getVersion();
    public A withVersion(String version);
    public Boolean hasVersion();
    public A withNewVersion(String arg1);
    public A withNewVersion(StringBuilder arg1);
    public A withNewVersion(StringBuffer arg1);
    public boolean isExposeService();
    public A withExposeService(boolean exposeService);
    public Boolean hasExposeService();
    public Integer getPort();
    public A withPort(Integer port);
    public Boolean hasPort();
    
/**
 * This method has been deprecated, please use method buildStorage instead.
 * @return The buildable object.
 */
@Deprecated public Storage getStorage();
    public Storage buildStorage();
    public A withStorage(Storage storage);
    public Boolean hasStorage();
    public A withNewStorage(String name,String capacity,String mode);
    public ComponentSpecFluent.StorageNested<A> withNewStorage();
    public ComponentSpecFluent.StorageNested<A> withNewStorageLike(Storage item);
    public ComponentSpecFluent.StorageNested<A> editStorage();
    public ComponentSpecFluent.StorageNested<A> editOrNewStorage();
    public ComponentSpecFluent.StorageNested<A> editOrNewStorageLike(Storage item);
    public A withEnvs(Env... envs);
    
/**
 * This method has been deprecated, please use method buildEnvs instead.
 */
@Deprecated public Env[] getEnvs();
    public Env[] buildEnvs();
    public Env buildEnv(int index);
    public Env buildFirstEnv();
    public Env buildLastEnv();
    public Env buildMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate);
    public Boolean hasMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate);
    public A addToEnvs(int index,Env item);
    public A setToEnvs(int index,Env item);
    public A addToEnvs(Env... items);
    public A addAllToEnvs(Collection<Env> items);
    public A removeFromEnvs(Env... items);
    public A removeAllFromEnvs(Collection<Env> items);
    public A removeMatchingFromEnvs(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate);
    public Boolean hasEnvs();
    public A addNewEnv(String name,String value);
    public ComponentSpecFluent.EnvsNested<A> addNewEnv();
    public ComponentSpecFluent.EnvsNested<A> addNewEnvLike(Env item);
    public ComponentSpecFluent.EnvsNested<A> setNewEnvLike(int index,Env item);
    public ComponentSpecFluent.EnvsNested<A> editEnv(int index);
    public ComponentSpecFluent.EnvsNested<A> editFirstEnv();
    public ComponentSpecFluent.EnvsNested<A> editLastEnv();
    public ComponentSpecFluent.EnvsNested<A> editMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<EnvBuilder> predicate);
    
/**
 * This method has been deprecated, please use method buildBuildConfig instead.
 * @return The buildable object.
 */
@Deprecated public BuildConfig getBuildConfig();
    public BuildConfig buildBuildConfig();
    public A withBuildConfig(BuildConfig buildConfig);
    public Boolean hasBuildConfig();
    public A withNewBuildConfig(String type,String url,String ref,String contextPath,String moduleDirName);
    public ComponentSpecFluent.BuildConfigNested<A> withNewBuildConfig();
    public ComponentSpecFluent.BuildConfigNested<A> withNewBuildConfigLike(BuildConfig item);
    public ComponentSpecFluent.BuildConfigNested<A> editBuildConfig();
    public ComponentSpecFluent.BuildConfigNested<A> editOrNewBuildConfig();
    public ComponentSpecFluent.BuildConfigNested<A> editOrNewBuildConfigLike(BuildConfig item);
    
/**
 * This method has been deprecated, please use method buildCapabilities instead.
 * @return The buildable object.
 */
@Deprecated public Capabilities getCapabilities();
    public Capabilities buildCapabilities();
    public A withCapabilities(Capabilities capabilities);
    public Boolean hasCapabilities();
    public ComponentSpecFluent.CapabilitiesNested<A> withNewCapabilities();
    public ComponentSpecFluent.CapabilitiesNested<A> withNewCapabilitiesLike(Capabilities item);
    public ComponentSpecFluent.CapabilitiesNested<A> editCapabilities();
    public ComponentSpecFluent.CapabilitiesNested<A> editOrNewCapabilities();
    public ComponentSpecFluent.CapabilitiesNested<A> editOrNewCapabilitiesLike(Capabilities item);

    public interface StorageNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,StorageFluent<ComponentSpecFluent.StorageNested<N>>{

        
    public N and();    public N endStorage();
}
    public interface EnvsNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,EnvFluent<ComponentSpecFluent.EnvsNested<N>>{

        
    public N and();    public N endEnv();
}
    public interface BuildConfigNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,BuildConfigFluent<ComponentSpecFluent.BuildConfigNested<N>>{

        
    public N and();    public N endBuildConfig();
}
    public interface CapabilitiesNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,CapabilitiesFluent<ComponentSpecFluent.CapabilitiesNested<N>>{

        
    public N and();    public N endCapabilities();
}


}
