package io.dekorate.halkyon.model;

import java.lang.StringBuffer;
import java.lang.StringBuilder;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class RequiredComponentCapabilityFluentImpl<A extends RequiredComponentCapabilityFluent<A>> extends ComponentCapabilityFluentImpl<A> implements RequiredComponentCapabilityFluent<A>{

    private String boundTo;
    private boolean autoBindable;

    public RequiredComponentCapabilityFluentImpl(){
    }
    public RequiredComponentCapabilityFluentImpl(RequiredComponentCapability instance){
            this.withName(instance.getName()); 
            this.withSpec(instance.getSpec()); 
            this.withParameters(instance.getParameters()); 
            this.withBoundTo(instance.getBoundTo()); 
            this.withAutoBindable(instance.isAutoBindable()); 
    }

    public String getBoundTo(){
            return this.boundTo;
    }

    public A withBoundTo(String boundTo){
            this.boundTo=boundTo; return (A) this;
    }

    public Boolean hasBoundTo(){
            return this.boundTo != null;
    }

    public A withNewBoundTo(String arg1){
            return (A)withBoundTo(new String(arg1));
    }

    public A withNewBoundTo(StringBuilder arg1){
            return (A)withBoundTo(new String(arg1));
    }

    public A withNewBoundTo(StringBuffer arg1){
            return (A)withBoundTo(new String(arg1));
    }

    public boolean isAutoBindable(){
            return this.autoBindable;
    }

    public A withAutoBindable(boolean autoBindable){
            this.autoBindable=autoBindable; return (A) this;
    }

    public Boolean hasAutoBindable(){
            return true;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            RequiredComponentCapabilityFluentImpl that = (RequiredComponentCapabilityFluentImpl) o;
            if (boundTo != null ? !boundTo.equals(that.boundTo) :that.boundTo != null) return false;
            if (autoBindable != that.autoBindable) return false;
            return true;
    }




}
