package io.dekorate.halkyon.model;

import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class StorageFluentImpl<A extends StorageFluent<A>> extends BaseFluent<A> implements StorageFluent<A>{

    private String name;
    private String capacity;
    private String mode;

    public StorageFluentImpl(){
    }
    public StorageFluentImpl(Storage instance){
            this.withName(instance.getName()); 
            this.withCapacity(instance.getCapacity()); 
            this.withMode(instance.getMode()); 
    }

    public String getName(){
            return this.name;
    }

    public A withName(String name){
            this.name=name; return (A) this;
    }

    public Boolean hasName(){
            return this.name != null;
    }

    public A withNewName(String arg1){
            return (A)withName(new String(arg1));
    }

    public A withNewName(StringBuilder arg1){
            return (A)withName(new String(arg1));
    }

    public A withNewName(StringBuffer arg1){
            return (A)withName(new String(arg1));
    }

    public String getCapacity(){
            return this.capacity;
    }

    public A withCapacity(String capacity){
            this.capacity=capacity; return (A) this;
    }

    public Boolean hasCapacity(){
            return this.capacity != null;
    }

    public A withNewCapacity(String arg1){
            return (A)withCapacity(new String(arg1));
    }

    public A withNewCapacity(StringBuilder arg1){
            return (A)withCapacity(new String(arg1));
    }

    public A withNewCapacity(StringBuffer arg1){
            return (A)withCapacity(new String(arg1));
    }

    public String getMode(){
            return this.mode;
    }

    public A withMode(String mode){
            this.mode=mode; return (A) this;
    }

    public Boolean hasMode(){
            return this.mode != null;
    }

    public A withNewMode(String arg1){
            return (A)withMode(new String(arg1));
    }

    public A withNewMode(StringBuilder arg1){
            return (A)withMode(new String(arg1));
    }

    public A withNewMode(StringBuffer arg1){
            return (A)withMode(new String(arg1));
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            StorageFluentImpl that = (StorageFluentImpl) o;
            if (name != null ? !name.equals(that.name) :that.name != null) return false;
            if (capacity != null ? !capacity.equals(that.capacity) :that.capacity != null) return false;
            if (mode != null ? !mode.equals(that.mode) :that.mode != null) return false;
            return true;
    }




}
